<?php

/*
 * Frontend Signup Site Clone - Edit New Fields Administration Page
 * Plugin URI: http://bigtester.com/
 * Version: 1.2.3
 * Author: Peidong Hu
 * Author URI: http://bigtester.com/
*/

//For Debugging and Testing Purposes ------------



// ----------------------------------------------

include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
include_once ("frontend-signup-site-clone-admin.php");
include_once ("frontend-signup-site-clone.php");
include_once ("frontend-signup-site-clone-options.php");
include_once ("frontend-signup-site-clone-regForm.php");

/**
 * Loads and displays the Frontend Signup Site Clone Edit New Fields Administration Page
 *
 * @since 1.1.0
 * @updated 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

if(!function_exists('bigtester_fessc_editNewFields')){
	function bigtester_fessc_editNewFields(){

	global $bigtester_fessc_knownFields, $bigtester_fessc_registrationFields, $bigtester_fessc_NewFields, $bigtester_fessc_Options, $bigtester_fessc_fieldOrder;
	
	
	//$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
		
		if(function_exists('bigtester_fessc_DefaultOptions')){
			bigtester_fessc_DefaultOptions();
		}
		
		
	$seperator = '';
	$results1 = '';
	$bigtester_fesscFields = get_option('bigtester_fesscFields');
	$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
	$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
	$bigtester_fessc_support = get_option('bigtester_fessc_support');
	$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
	$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
	$fieldKey = '';
	$fieldOrder = '';
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	// Double checks to see that the new field order is updated
	
	if(!empty($bigtester_fessc_NewFields)){
		if(empty($bigtester_fessc_fieldOrder)){
			include("user-reg-aide-admin.php");
			bigtester_fessc_update_field_order();
		}
	}
	
	// Handles the delete field form
	
	if (isset($_POST['delete_field'])){
		
		$results1 = '';
		$csds_current_user = wp_get_current_user();
		
		if(current_user_can('activate_plugins')){
		
			$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
			$bigtester_fesscFields = get_option('bigtester_fesscFields');
			$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
			$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
			
			// Checking for field to delete if empty gives warning and exits
			
			if(!empty($_POST['deleteNewFields'])){
				$results1 =  $_POST['deleteNewFields'];
			}else{
				echo '<div id="message" class="updated fade"><p>'. __('No field was selected for deletion, you must select a field to delete first!' , 'bigtester_fessc') .'</p></div>';
				exit();
			}
			unset($bigtester_fessc_NewFields[$results1]);
			unset($bigtester_fesscFields[$results1]);
			unset($bigtester_fessc_fieldOrder[$results1]);
			unset($bigtester_fessc_registrationFields[$results1]);
			$bigtester_fessc_NewFields = $bigtester_fessc_NewFields;
			$bigtester_fesscFields = $bigtester_fesscFields;
			$bigtester_fessc_fieldOrder = $bigtester_fessc_fieldOrder;
			$bigtester_fessc_registrationFields = $bigtester_fessc_registrationFields;
			update_option("bigtester_fessc_NewFields", $bigtester_fessc_NewFields);
			update_option("bigtester_fesscFields", $bigtester_fesscFields);
			update_option("bigtester_fessc_fieldOrder", $bigtester_fessc_fieldOrder);
			update_option("bigtester_fessc_registrationFields", $bigtester_fessc_registrationFields);
			
			if(function_exists('csds_delete_field_from_users_meta')){
				csds_delete_field_from_users_meta($results1);  // Deletes field from user meta
			}
			//Report to the user that the data has been updated successfully or that an error has occurred
			
			echo '<div id="message" class="updated fade"><p>'. __( $results1.' Successfully Deleted!' , 'bigtester_fessc') .'</p></div>';			
		}else{
			echo '<div id="message" class="updated fade"><p>'. __('You do not have adequate permissions to edit this plugin! Please check with Administrator to get additional permissions.', 'bigtester_fessc') .'</p></div>';
			exit();
		}
	
	// Handles the new fields order form
	
	}elseif (isset($_POST['field_order'])){
		
		$key = '';
		$key1 = '';
		$key2 = '';
		$value = '';
		$value1 = '';
		$value2 = '';
		$results = '';
		$aa = '';
		
		$csds_current_user = wp_get_current_user();
		
		if(current_user_can('activate_plugins')){
			$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
							
			// Getting values from new field order select options
				
			$results = $_POST['csds_editFieldOrder'];
			$aa = 0;
				
			foreach($bigtester_fessc_fieldOrder as $key => $value){
				foreach($results as $key1 => $value1){
					foreach($results as $key2 => $value2){
						if($key1 != $key2 && ($value1 == $value2)){
							echo '<div id="message" class="updated fade"><p>'. __('Error Updating New Field Order Options, two or more fields have the same order!', 'bigtester_fessc') .'</p></div>';
						exit();
						}
					}
					if($aa == $key1){
						$bigtester_fessc_fieldOrder_temp[$key] = $value1;
					}	
				}
						
			$aa++;
			}
					
			// Updating New Field Order
				
			$bigtester_fessc_fieldOrder = $bigtester_fessc_fieldOrder_temp;
			asort($bigtester_fessc_fieldOrder);
			update_option("bigtester_fessc_fieldOrder", $bigtester_fessc_fieldOrder);
				
				// Updating New Fields to new Order
				
			foreach($bigtester_fessc_fieldOrder as $key => $order){
				foreach($bigtester_fessc_NewFields as $key1 => $name1){
					if($key == $key1){
						$bigtester_fessc_NewFields_temp[$key1] = $name1;
					}
				}
			}
			
			// Updating field order in database
			
			$bigtester_fessc_NewFields = $bigtester_fessc_NewFields_temp;
			update_option("bigtester_fessc_NewFields", $bigtester_fessc_NewFields);
			$bigtester_fessc_knownFields;	
			$bigtester_fesscFields = array();
			$bigtester_fesscFields = $bigtester_fessc_knownFields + $bigtester_fessc_NewFields;
			update_option("bigtester_fesscFields", $bigtester_fesscFields);
			echo '<div id="message" class="updated fade"><p>'. __('New Field Order Options updated successfully.', 'bigtester_fessc') .'</p></div>';
		}else{
			echo '<div id="message" class="updated fade"><p>'. __('You do not have adequate permissions to edit this plugin! Please check with Administrator to get additional permissions.', 'bigtester_fessc') .'</p></div>';
		}
	}elseif (isset($_POST['bigtester_fessc_support_submit'])){
		$update = array();
		$update = get_option('bigtester_fessc_Options');
		$update['show_support'] = esc_attr(stripslashes($_POST['bigtester_fessc_support']));
		update_option("bigtester_fessc_Options", $update);
		echo '<div id="message" class="updated fade"><p>'. __('Support Options updated successfully.', 'bigtester_fessc') .'</p></div>'; //Report to the user that the data has been updated successfully
	}else{
		$bigtester_fessc_getOptions = get_option('bigtester_fessc');
		
	}
		
	// Checks to make sure that the known fields were loaded on installation 

	if(!empty($bigtester_fessc_knownFields)){
		
		// Loads additional options needed for page just in case
		
		$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
		$bigtester_fesscFields = get_option('bigtester_fesscFields');
		$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
		$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
		
		
		// Checks to see if any new fields exist and if not displays message telling user to create some new fields before editing them
		
		if(empty($bigtester_fessc_NewFields)){
			echo '<div id="message" class="updated fade"><p>'. __('No new fields have been created, please go to the main page to add some new fields first before you try and edit them! ', 'bigtester_fessc') .'</p></div>';
			exit();
		}

// Displays the Edit New Additional Fields Administration Page
		
echo '<div id="wpbody">';
	echo '<div class=wrap>';
		echo '<form method="post" name="bigtester_fessc">';
            echo '<h2>'. __('Frontend Signup Site Clone: Edit New Fields', 'bigtester_fessc') .'</h2>';
			
			// Delete new fields form
			
            echo '<div id="poststuff">';       
                echo '<div class="stuffbox">';
                    ?><h3><?php _e('Edit Additional Fields for Profile &  Registration Form: Delete Field', 'bigtester_fessc'); ?>
					</h3>
						<div class="inside">
                        
						<p><?php _e('Here you can select the new additional fields you added that you want to delete.', 'bigtester_fessc'); ?>
						</p>
						<?php
                        echo '<select name="deleteNewFields" id="csds_userRegMod_delete_Select" size="8"  style="height:100px">';
                       
                            foreach($bigtester_fessc_NewFields as $fieldKey => $fieldName){
								echo '<option value="'.$fieldKey.'">'.$fieldName.'</option>';
                            }
							                        
						echo '</select>';
						
                    	echo '<br/>';
						
						?>
						
					   	<div class="submit"><input type="submit" class="button-primary" name="delete_field" value="<?php _e('Delete New Field', 'bigtester_fessc'); ?>"  /></div>
						</div>
					    </div>
						
		<?php 	// Edit new field order form ?>
		
				<div class="stuffbox">
				<h3><?php _e('Edit New Field Order', 'bigtester_fessc');?></h3>
				<div class="inside">
					<?php 
						$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
						echo '<p>'?><?php _e('Here you can select or change the order for the new additional fields on the registration form and profile. You must not have the same number twice, so make sure you change all fields accordingly so there are no duplicates or you will generate an error!', 'bigtester_fessc') .'</p>';
						
						$i = '';
						$cnt = '';
						$fieldKey = '';
						$fieldOrder = '';
						$fieldKeyUpper = '';
						
						$i = count($bigtester_fessc_fieldOrder);
						$cnt = 1;
						
						// Table for field order
						echo '<br/>';
						echo '<table border="5" cellpadding="5" cellspacing="5">';
						echo '<tr>';
						echo '<td >'. __('Additional New Field Name: ', 'bigtester_fessc').'</td>';
						echo '<td>'. __('Current Field Order: ', 'bigtester_fessc').'</td>';
						echo '</tr>';
                            foreach($bigtester_fessc_fieldOrder as $fieldKey => $fieldOrder){
								echo '<tr>';
								echo '<td align="center">';
								$fieldKeyUpper = strtoupper($fieldKey);
								echo '<label for="'.$fieldKey.'">'.$fieldKeyUpper.'</label>';
								//Changed from check box to label here
								
								echo '</td>';
								echo '<td align="center">';
								echo '<select name="csds_editFieldOrder[]">';
                       
								for($ii = 1; $ii <= $i; $ii++){
									if($ii == $fieldOrder){
										echo '<option selected="'.$fieldKey.'" >'.$fieldOrder.'</option>';
									}else{
										echo '<option value="'.$ii.'">'.$ii.'</option>';
									}									
								}
								echo '</td>';
								$cnt ++;
							    echo '</select>';
								echo '</tr>';
                            }
						echo '</table>';
						echo '<div class="submit"><input type="submit" class="button-primary" name="field_order" value="'. __('Update Field Order', 'bigtester_fessc').'"  /></div>';
					echo '</div>';
				echo '</div>';
				
						// Plugin Help & Support Form
				
						echo '<div class="stuffbox">';
						echo '<h3><a href="http://bigtester.com" target="_blank">Creative Software Design Solutions</a></h3>';
						echo '<div class="inside">';
						echo '<p>';?>
						<?php _e('Show Plugin Support: ', 'bigtester_fessc'); ?><input type="radio" id="bigtester_fessc_support" name="bigtester_fessc_support"  value="1"<?php
						if ($bigtester_fessc_Options['show_support'] == 1) echo 'checked' ;?>/> Yes
						<input type="radio" id="bigtester_fessc_support" name="bigtester_fessc_support"  value="2" <?php
						if ($bigtester_fessc_Options['show_support'] == 2) echo 'checked' ;?>/> No
						<br/>
						<br/>

							<?php
								echo '<input name="bigtester_fessc_support_submit" id="bigtester_fessc_support_submit" lang="publish" class="button-primary" value="Update" type="Submit" />';?><h2><?php _e('Plugin Configuration Help', 'bigtester_fessc');?></h2>
								<ul>
									<li><a href="http://bigtester.com/" target="_blank">Plugin Page & Screenshots</a></li>
								</ul>
								<h2><?php _e('Check Official Website', 'bigtester_fessc');?></h2>
								<ul>
									<li><a href="http://bigtester.com/" target="_blank">Check official website for live demo</a></li>
									<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
									<input type="hidden" name="cmd" value="_s-xclick">
									<input type="hidden" name="hosted_button_id" value="6BCZESUXLS9NN">
									<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
									<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
									</form>

							    </ul>
				<?php	echo '</div>';
					echo '</div>';
				echo '</div>';   
			echo '</form>';
		echo '</div>';
	echo '</div>';
	 }
	else{
		// loads known fields if they havent been loaded yet as a safety 
		// measure as I ran into some instances where they dont show up when page loads after install
		if(function_exists('bigtester_fessc_fill_known_fields')){
			bigtester_fessc_fill_known_fields();
		}
	}
	}
}

?>