<?php
/*
 * Frontend Signup Site Clone - Edit New Fields Administration Page
 * Plugin URI: http://bigtester.com/
 * Version: 1.2.3
 * Author: Peidong Hu
 * Author URI: http://bigtester.com/
*/

//For Debugging and Testing Purposes ------------



// ----------------------------------------------

include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
include_once ("frontend-signup-site-clone-admin.php");
include_once ("frontend-signup-site-clone.php");
include_once ("frontend-signup-site-clone-newFields.php");
include_once ("frontend-signup-site-clone-regForm.php");

/**
 * Adds the new default options for the options fields on admin forms
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_DefaultOptions(){
	global $pagenow;
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');

	if(empty($bigtester_fessc_Options)){

		$bigtester_fessc_Options = array(
			"bigtester_fessc_db_Version" => "0.1",
			"bigtester_fessc_template_id" => "1",
		);
		
		update_option("bigtester_fessc_Options", $bigtester_fessc_Options);
		
		// For updates from older versions
		
		//delete_option('bigtester_fessc_support');
		if ( is_admin() && $pagenow !== 'plugins.php' ) {
			if(function_exists('bigtester_fessc_myOptionsSubpanel')){
				bigtester_fessc_myOptionsSubpanel();
			}
		}
		
	}else{
		$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	}
	return $bigtester_fessc_Options;
}

/**
 * Fills array of known fields
 *
 * @since 1.0.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
if(!function_exists('bigtester_fessc_fill_known_fields')){
	function bigtester_fessc_fill_known_fields(){
		global $pagenow;
		
		if(!empty($bigtester_fessc_knownFields) && !empty($bigtester_fesscFields)){
			$bigtester_fessc_knownFields = array();
			$bigtester_fesscFields = array();
		}
		
		$bigtester_fessc_knownFields = array(
		"blogdescription"	=> "Site Description",
		);
		
		update_option("bigtester_fesscFields", $bigtester_fessc_knownFields);
		update_option("bigtester_fessc_knownFields", $bigtester_fessc_knownFields);
			
		//update the db options in the plugin upgrade
		if(empty($bigtester_fessc_registrationFields)){
			bigtester_fessc_updateRegistrationFields();
		}
		
		// Redirects back to admin page after fields are loaded or reloaded
		if ( is_admin() && $pagenow !== 'plugins.php' ) {
			if(function_exists('bigtester_fessc_myOptionsSubpanel')){
				bigtester_fessc_myOptionsSubpanel();
			}
		}
	}
}

/**
 * Updates the registration fields array and storage method in options db upgrade in 1.1.0
 *
 * @since 1.1.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

if(!function_exists('bigtester_fessc_updateRegistrationFields')){
	function bigtester_fessc_updateRegistrationFields(){
	//used to upgrade the options db in the version upgrade of the plugin		
	}
}

/**
 * Fills and arranges the order of new fields based on order of creation initially
 *
 * @since 1.1.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

if(!function_exists('bigtester_fessc_update_field_order')){
	function bigtester_fessc_update_field_order(){
		$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
		$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
		$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
		$bigtester_fesscFields = get_option('bigtester_fesscFields');
		if(empty($bigtester_fessc_fieldOrder)){
			if(!empty($bigtester_fessc_NewFields)){
				$i = 1;
				foreach($bigtester_fessc_NewFields as $key => $field){
					$bigtester_fessc_fieldOrder[$key] = $i;
					
					$i++;
				}
			}
			$bigtester_fesscFields = array();
			$bigtester_fesscFields = $bigtester_fessc_knownFields + $bigtester_fessc_NewFields;
		}
		
		update_option("bigtester_fessc_fieldOrder", $bigtester_fessc_fieldOrder);
	}
}
?>