<?php

/*
 * Frontend Signup Site Clone - Registration Form Options
 * Plugin URI: http://bigtester.com/
 * Version: 1.2.3
 * Author: Peidong Hu
 * Author URI: http://bigtester.com/
*/

//For Debugging and Testing Purposes ------------



// ----------------------------------------------

/**
 * Couple of includes for functionality
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
include_once ("frontend-signup-site-clone.php");
include_once ("frontend-signup-site-clone-options.php");
include_once ("frontend-signup-site-clone-newFields.php");
include_once ("frontend-signup-site-clone-admin.php");

/**
 * Loads and displays the Frontend Signup Site Clone administration page
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

//if(!function_exists('bigtester_fessc_regFormOptions')){
function bigtester_fessc_regFormOptions(){

	global $bigtester_fessc_knownFields, $bigtester_fessc_Options, $bigtester_fessc_registrationFields, $bigtester_fessc_NewFields, $bigtester_fessc_fieldOrder;
		
		
	if(empty($bigtester_fessc_registrationFields)){
		if(function_exists('bigtester_fessc_updateRegistrationFields')){
			bigtester_fessc_updateRegistrationFields();
		}
	}
		
	if (isset($_POST['reg_form_message_update'])){
			
		// add code to handle new registration form message
		$update = array();
		$update = get_option('bigtester_fessc_Options');
		update_option("bigtester_fessc_Options", $update);
		echo '<div id="message" class="updated fade"><p>'. __('New Registration Form Message Options updated successfully.', 'bigtester_fessc') .'</p></div>'; //Report to the user that the data has been updated successfully
						
	}elseif (isset($_POST['reg_form_agreement_message_update'])){
		$update = array();
		$update = get_option('bigtester_fessc_Options');
		update_option("bigtester_fessc_Options", $update);
		echo '<div id="message" class="updated fade"><p>'. __('New Registration Form Agreement Message Options updated successfully.', 'bigtester_fessc') .'</p></div>'; //Report to the user that the data has been updated successfully
	
	}elseif (isset($_POST['bigtester_fessc_logo_update'])){
		$update = array();
		$update = get_option('bigtester_fessc_Options');
		update_option("bigtester_fessc_Options", $update);
		echo '<div id="message" class="updated fade"><p>'. __('New Registration Form Logo Options updated successfully.', 'bigtester_fessc') .'</p></div>'; //Report to the user that the data has been updated successfully
	
	}
	
	$bigtester_fessc_getOptions = get_option('bigtester_fessc');
	$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
	$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
	$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
	$bigtester_fessc_fieldOrder = get_option('bigtester_fessc_fieldOrder');
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
				
	$cnt1 = count($bigtester_fessc_knownFields);
	if($cnt1 < 8 ){
		if(function_exists('bigtester_fessc_fill_known_fields')){
			bigtester_fessc_fill_known_fields();
		}
	}
	
	if(!empty($bigtester_fessc_knownFields)){
		if(!empty($bigtester_fessc_Options)){

		
		
		// Shows Aministration Page 
				
	echo '<div id="wpbody">';
		echo '<div class=wrap>';
			echo '<form method="post" name="bigtester_fessc">';
				echo '<h2>'. __('Frontend Signup Site Clone: Force New User Registration Fields', 'bigtester_fessc') .'</h2>';
				echo '<div id="poststuff">';
				
				//Form for adding different message to registration form
					
			echo '<div class="stuffbox">';
					echo '<h3>'.__('Add Your Own Message to Bottom of Registration Form', 'bigtester_fessc');
					echo '</h3>';
					echo '<div class="inside">';
						echo '<table border="5" cellpadding="5" cellspacing="5">';
						echo '<tr>';
							echo '<td>'. __('Choose to add a special message to bottom of registration form if new users can enter own password:', 'bigtester_fessc').'</td>';
							?><td><input type="radio" name="csds_select_RegFormMessage" id="csds_select_RegFormMessage" value="1" <?php
								if ($bigtester_fessc_Options['select_pass_message'] == 1) echo 'checked' ;?>/> Yes 
								<input type="radio" name="csds_select_RegFormMessage" id="csds_select_RegFormMessage" value="2" <?php
								if ($bigtester_fessc_Options['select_pass_message'] == 2) echo 'checked' ;?>/> No </td>
													
							<td><?php _e('Enter new Registration form message below: ', 'bigtester_fessc');?></td></tr>
						<tr>
							<td colspan="3"><textarea name="csds_RegForm_Message" id="csds_RegForm_Message" cols="180" rows="1" 
							wrap="hard" title="<?php _e('Enter a custom message here for bottom of registration form if users can create their own password!', 'bigtester_fessc');?>"><?php _e($bigtester_fessc_Options['registration_form_message'],'bigtester_fessc')?></textarea>
							</td>
						</tr>
						</table>
						<div class="submit"><input type="submit" class="button-primary" name="reg_form_message_update" value="<?php _e('Update Registration Form Message Options', 'bigtester_fessc'); ?>"  /></div>
					</div>
				</div>
												
			<?php 	// Form for adding additional agreement to signup for website
				echo '<div class="stuffbox">';
					?><h3><?php _e('Add Your Own Agreement Message and Policy Link with Confirmation of Agreement to Bottom of Registration Form', 'bigtester_fessc');?></h3>
						<div class="inside">
						<table border="5" cellpadding="5" cellspacing="5">
						<tr>
							<td colspan="3"><?php _e('Choose to add a special message to bottom of registration form for new users requiring them to read and agree to terms and conditions of the website:', 'bigtester_fessc'); ?></td>
						</tr>
						<tr>
							<td width="25%"><?php _e('Show Custom Link for Agreement/Guidelines/Policy Page: ', 'bigtester_fessc'); ?><input type="radio" id="bigtester_fessc_agreement_link" name="bigtester_fessc_agreement_link" value="1" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_link'] == 1) echo 'checked' ;?>/> Yes
								<input type="radio" id="bigtester_fessc_agreement_link" name="bigtester_fessc_agreement_link"  value="2" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_link'] == 2) echo 'checked' ;?>/> No
							</td><?php 
							echo '<td width="25%">'. __('Enter a title to display for link to Agreement/Guidelines/Policies URL: ', 'bigtester_fessc').'<input  style="width: 200px;" type="text" title="Enter the title for the URL where your agreement/guidelines/policy page is located (http://mysite.com/agreement.php)" value="' . $bigtester_fessc_Options['agreement_title'] . '" name="bigtester_fessc_newAgreementTitle" id="bigtester_fessc_newAgreementTitle" /></td>';
							echo '<td width="50%">'. __('Enter Link to Agreement/Guidelines/Policies URL: ', 'bigtester_fessc') .'<input  style="width: 450px;" type="text" title="Enter the URL where your agreement/guidelines/policy page is located (http://mysite.com/agreement.php)" value="' . $bigtester_fessc_Options['agreement_link'] . '" name="bigtester_fessc_newAgreementURL" id="bigtester_fessc_newAgreementURL" /></td>';?></tr>
						<tr>
							<td width="25%"><?php _e('Show Message Confirming Agreement for Agreement/Guidelines/Policy Page: ', 'bigtester_fessc'); ?><input type="radio" id="bigtester_fessc_show_agreement_message" name="bigtester_fessc_show_agreement_message" value="1" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_message'] == 1) echo 'checked' ;?>/> Yes
								<input type="radio" id="bigtester_fessc_show_agreement_message" name="bigtester_fessc_show_agreement_message"  value="2" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_message'] == 2) echo 'checked' ;?>/> No
							</td>
							<td width="25%"><?php _e('Show Checkbox Confirming Agreement for Agreement/Guidelines/Policy Page: ', 'bigtester_fessc'); ?><input type="radio" id="bigtester_fessc_agreement_checkbox" name="bigtester_fessc_agreement_checkbox" value="1" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_checkbox'] == 1) echo 'checked' ;?>/> Yes
								<input type="radio" id="bigtester_fessc_agreement_checkbox" name="bigtester_fessc_agreement_checkbox"  value="2" <?php
								if ($bigtester_fessc_Options['show_custom_agreement_checkbox'] == 2) echo 'checked' ;?>/> No
							</td>
							<td><?php _e('Add your special message below to add to bottom of registration form if new users must agree to terms or policies:', 'bigtester_fessc');?></td>
						<tr>
							<td colspan="3"><textarea name="csds_RegForm_Agreement_Message" id="csds_RegForm_Agreement_Message" cols="180" rows="1" 
							wrap="hard" title="<?php _e('Enter a custom message here for bottom of registration form if users can create their own password!', 'bigtester_fessc');?>"><?php _e($bigtester_fessc_Options['agreement_message'],'bigtester_fessc')?></textarea>
							</td>
						</tr></table>
							<div class="submit"><input type="submit" class="button-primary" name="reg_form_agreement_message_update" value="<?php _e('Update Registration Form Agreement Options', 'bigtester_fessc');?>" /></div>
						</div>
					</div><?php
					// Form area for adding custom logo
					
					echo '<div class="stuffbox">';?><h3><?php _e('Add Your Own Logo', 'bigtester_fessc');?></h3><?php
						echo '<div class="inside">';
						echo '<br/>';
						echo '<table border="5" cellpadding="5" cellspacing="5">';
						echo '<tr>';
						// Custom Logo
						?>
						<td width="25%"><?php _e('Show Custom Logo: ', 'bigtester_fessc'); ?><input type="radio" id="bigtester_fessc_logo" name="bigtester_fessc_logo" value="1"
						<?php if ($bigtester_fessc_Options['show_logo'] == 1) echo 'checked' ;?>/> Yes
						<input type="radio" id="bigtester_fessc_logo" name="bigtester_fessc_logo"  value="2" <?php
						if ($bigtester_fessc_Options['show_logo'] == 2) echo 'checked' ;?>/> No
						</td>
						<td width="25%">
						<?php _e('Change Custom Logo Link: ', 'bigtester_fessc');?><input type="radio" id="bigtester_fessc_change_logo_link" name="bigtester_fessc_change_logo_link" value="1" <?php
						if ($bigtester_fessc_Options['change_logo_link'] == 1) echo 'checked' ;?>/> Yes
						<input type="radio" id="bigtester_fessc_change_logo_link" name="bigtester_fessc_change_logo_link"  value="2" <?php
						if ($bigtester_fessc_Options['change_logo_link'] == 2) echo 'checked' ;?>/> No
						</td>
						<?php
						echo '<td width="50%">'. __('New Logo URL: ', 'bigtester_fessc') .'<input  style="width: 450px;" type="text" title="Enter the URL where your new logo is for your register/login page -- (http://mysite.com/wp-content/uploads/9/5/thislogo.png)" value="' . $bigtester_fessc_Options['logo_url'] . '" name="bigtester_fessc_newLogoURL" id="bigtester_fessc_newLogoURL" /></td>';
						echo '</tr>';
						
						// Form Background Image
						
						echo '<tr>';
						echo '<td>';?>
						<?php _e('Show Custom Background Image: ', 'bigtester_fessc'); ?>
						<br/>
						<input type="radio" id="bigtester_fessc_background_image" name="bigtester_fessc_background_image" value="1" <?php
						if ($bigtester_fessc_Options['show_background_image'] == 1) echo 'checked' ; ?> /> Yes
						<input type="radio" id="bigtester_fessc_background_image" name="bigtester_fessc_background_image" value="2"
						<?php
						if ($bigtester_fessc_Options['show_background_image'] == 2) echo 'checked' ; ?> /> No
						</td>
						<?php echo '<td colspan="2">'. __('New Background Image URL: ', 'bigtester_fessc') .'<input  style="width: 450px;" type="text" title="Enter the URL where your new background image is for your login/register forms --  (http://mysite.com/wp-content/uploads/9/5/this-background-image.png)" value="' . $bigtester_fessc_Options['background_image_url'] . '" name="bigtester_fessc_newBackgroundImageURL" id="bigtester_fessc_newBackgroundImageURL" /></td>';
						echo '</tr>';
						
						// Page Background Image
						
						?><tr>
						<td>
						<?php _e('Show Custom Page Background Image: ', 'bigtester_fessc');?><input type="radio" id="bigtester_fessc_page_background_image" name="bigtester_fessc_page_background_image" value="1"
						<?php if ($bigtester_fessc_Options['show_reg_form_page_image'] == 1) echo 'checked';?>/> Yes
						<input type="radio" id="bigtester_fessc_page_background_image" name="bigtester_fessc_page_background_image" value="2" 
						<?php if ($bigtester_fessc_Options['show_reg_form_page_image'] == 2) echo 'checked' ;?>/> No
						</td><?php echo '<td colspan="2">'. __('New Page Background Image: ', 'bigtester_fessc') .'<input  style="width: 150px;" type="text" title="Enter the new page background image url for your register/login pages (http://mysite.com/content/uploads/myimage.png)" value="' . $bigtester_fessc_Options['reg_form_page_image'] . '" name="bigtester_fessc_newPageBackgroundImage" id="bigtester_fessc_newPageBackgroundImage" /></td></tr>';
						
						// Form Background Color
						
						echo '<tr>';?>
						<td>
						<?php _e('Show Custom Background Color: ', 'bigtester_fessc');?><input type="radio" id="bigtester_fessc_background_color" name="bigtester_fessc_background_color" value="1"
						<?php if ($bigtester_fessc_Options['show_background_color'] == 1) echo 'checked';?>/> Yes
						<input type="radio" id="bigtester_fessc_background_color" name="bigtester_fessc_background_color" value="2" 
						<?php if ($bigtester_fessc_Options['show_background_color'] == 2) echo 'checked' ;?>/> No
						</td><?php echo '<td colspan="2">'. __('New Background Color: ', 'bigtester_fessc') .'<input  style="width: 150px;" type="text" title="Enter the new background color for your login/register form (#FFFFFF)" value="' . $bigtester_fessc_Options['reg_background_color'] . '" name="bigtester_fessc_newBackgroundColor" id="bigtester_fessc_newBackgroundColor" />';?>
						</td>
						</tr>
						
						<?php // Page Background Color?>
						
						<tr>
						<td>
						<?php _e('Show Custom Page Background Color: ', 'bigtester_fessc');?><input type="radio" id="bigtester_fessc_page_background_color" name="bigtester_fessc_page_background_color" value="1"
						<?php if ($bigtester_fessc_Options['show_reg_form_page_color'] == 1) echo 'checked';?>/> Yes
						<input type="radio" id="bigtester_fessc_page_background_color" name="bigtester_fessc_page_background_color" value="2" 
						<?php if ($bigtester_fessc_Options['show_reg_form_page_color'] == 2) echo 'checked' ;?>/> No
						</td><?php echo '<td colspan="2">'. __('New Page Background Color: ', 'bigtester_fessc') .'<input  style="width: 150px;" type="text" title="Enter the new page background color for your register/login form (#FFFFFF)" value="' . $bigtester_fessc_Options['reg_form_page_color'] . '" name="bigtester_fessc_newPageBackgroundColor" id="bigtester_fessc_newPageBackgroundColor" /></td></tr>';?>
						
						<?php // Text label and link colors?>
						<tr>
						<td>
						<?php _e('Show Custom Text/Links Colors: ', 'bigtester_fessc');?><input type="radio" id="bigtester_fessc_text_color" name="bigtester_fessc_text_color" value="1"
						<?php if ($bigtester_fessc_Options['show_login_text_color'] == 1) echo 'checked';?>/> Yes
						<input type="radio" id="bigtester_fessc_text_color" name="bigtester_fessc_text_color" value="2" 
						<?php if ($bigtester_fessc_Options['show_login_text_color'] == 2) echo 'checked' ;?>/> No
						</td><?php echo '<td>'. __('New Text/Links Color: ', 'bigtester_fessc') .'<input  style="width: 100px;" type="text" title="Enter the new text/links color for your site (#FFFFFF)" value="' . $bigtester_fessc_Options['login_text_color'] . '" name="bigtester_fessc_newTextColor" id="bigtester_fessc_newTextColor" />';?>
						</td><?php echo '<td>'. __('New Links Hover Color: ', 'bigtester_fessc') .'<input  style="width: 100px;" type="text" title="Enter the new hover color for your login page links (#FFFFFF)" value="' . $bigtester_fessc_Options['hover_text_color'] . '" name="bigtester_fessc_newHoverTextColor" id="bigtester_fessc_newHoverTextColor" />';
						echo '</td>';
						echo '</tr>';
						echo '</table>';
						echo '<br/>';
						echo '<input type="submit" class="button-primary" name="bigtester_fessc_logo_update" value="'. __('Add Logo', 'bigtester_fessc').'" />';
						echo '</div>';
					echo '</div>';
				echo '</div>';   
			echo '</form>';
		echo '</div>';
	echo '</div>';
		}else{
			if(function_exists('bigtester_fessc_DefaultOptions')){
				bigtester_fessc_DefaultOptions();
			}
		}
		 
	}else{
		if(function_exists('bigtester_fessc_fill_known_fields')){
			bigtester_fessc_fill_known_fields();
		}
	}
}
?>