<?php
/*
Plugin Name: Frontend Signup Site Clone
Plugin URI: 
Description: Clone a site in user signup process.
Version: 0.1
Author: Peidong Hu
Author URI: http://bigtester.com/
License: GPL2
*/

/*
Copyright 2012 Peidong @ Montreal Prot QA ( peidong@bigtester.com )
Copyright (c) 2012 Brian Novotny
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

/*
 Text Domain: frontend-signup-site-clone

Frontend Signup Site Clone Requires & Adds More Fields to User Registration & Profile - Forces new users to register additional fields
on registration form, and gives you the option to clone an existing site as the new site template!
Copyright (c) 2012 Peidong Hu

Users Signup Helper - Forces new users to register additional fields and clone a template site.
*/

include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
include_once ("frontend-signup-site-clone-admin.php");
include_once ("frontend-signup-site-clone-newFields.php");
include_once ("frontend-signup-site-clone-options.php");
include_once ("frontend-signup-site-clone-regForm.php");



//For Debugging and Testing Purposes ------------



// ----------------------------------------------

/**
 * Creates Class CSDS_USER_REG_AIDE & Adds Actions and Hooks to register 
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://www.bigtester.com
*/
	if( isset($_GET['page']) && $_GET['page'] == 'frondend-signup-site-clone-admin' ){
			add_action( 'init',  'bigtester_fessc_fill_known_fields' );
	}
	if(isset($_GET['action']) && $_GET['action'] == 'admin_init'){
		add_action( 'init', 'bigtester_fessc_DefaultOptions' );
	}
	register_activation_hook( __FILE__, 'bigtester_fessc_install' );
	add_action('signup_blogform', 'bigtester_fessc_addFields');
		
	add_filter('wpmu_validate_blog_signup', 'bigtester_fessc_updateFields', 10, 1);
	add_filter('add_signup_meta', 'bigtester_fessc_addMetaFields', 10, 1);
	//add_filter('blog_details', 'bigtester_fessc_correctBlogID', 10, 1);
	
	//add_filter( 'registration_errors', 'bigtester_fessc_checkFields', 10, 3);
	
	
	add_action('admin_menu', 'bigtester_fessc_optionsPage');
	add_action('wpmu_activate_blog', 'bigtester_fessc_cloneSite',10,5);
	add_action('signup_finished', 'bigtester_fessc_cloneAnotherSite');
	
	register_deactivation_hook(__FILE__, 'bigtester_fessc_deactivation');
	
/**
 * Installs stuff for plugin
 *
 * @since 1.0.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
	
function bigtester_fessc_install(){
	
	if(function_exists('bigtester_fessc_fill_known_fields')){
		bigtester_fessc_fill_known_fields();
	}
	
	if(function_exists('bigtester_fessc_DefaultOptions')){
		bigtester_fessc_DefaultOptions();
	}

}


/**
 * clone another site for signed user
 *
 * @since 1.0.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
 */
function bigtester_fessc_cloneAnotherSite() {
	//if this call is made by confirm_another_blog_signup then do clone, 
	//else will need to wait the activation action of the user.
	
	if ( is_user_logged_in() )
	{
		
		$maxblog_id = 0;
		
		$current_user = wp_get_current_user();
		$blogs = get_blogs_of_user($current_user->ID, false);
		if ( !empty($blogs) ) { 
			foreach ( $blogs as $blog ) {
				if ($blog->userblog_id > $maxblog_id)
					$maxblog_id = $blog->userblog_id;
			}
		} 
		bigtester_fessc_cloneSite($maxblog_id,$current_user->ID,'',$blogs[$maxblog_id]->blogname,null);
	}
}

// some functions
function bigtester_fessc_trim_value(&$value) {
	$value = trim(trim($value), ' ,');
}
function bigtester_fessc_valid_url($str){
	return ( ! preg_match('/^([A-Z0-9][A-Z0-9_-]*(?:\.[A-Z0-9][A-Z0-9_-]*)+):?(\d+)?\/?/i', $str)) ? FALSE : TRUE;
}


/**
 * clone site for plugin
 *
 * @since 1.0.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
 */

function bigtester_fessc_cloneSite($blog_id, $user_id, $password, $title, $meta){
global $wpdb;

// STIL TODO for future releases:
// settings for choosing templates
// settings for options: - copy posts, data/ etc  
// set public or private (google)
// make update possible
// reward donations
// make translation ok ->


// start timing
$time_start = microtime(true);
$error = NULL;
$cloned = NULL;
$failed = NULL;
 
// Get POST data
$template_id = get_option("bigtester_fessc_template_id");
$domainmap = FALSE; 
$copy_images = TRUE;
$subdomain_install = true;

$pluginUrl = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));

// get site admin email
$admin_info = get_userdata($user_id);
$admin_email = $admin_info->user_email;
 

// get data for single site
$blog_details = get_blog_details($blog_id);
$siteurl = $blog_details->siteurl;
$domain = $blog_details->domain;
$fulldomain = $blog_details->domain;
$path = "/";
$blogname = $title;
$blogdescription = get_blog_option($blog_id, 'blogdescription');
$the_array[0][0] = $siteurl;
$the_array[0][1] = $blogdescription;
$the_array[0][2] = $blogname;
$the_array[0][3] = $user_id;
$the_array[0][4] = $admin_email;
$the_array[0][5] = $template_id;

// trim each value in the array from whitespaces and left comma's
for ( $i = 0; $i < sizeof( $the_array ); $i++ ) {
	array_walk($the_array[$i], 'bigtester_fessc_trim_value');
}

//before duplicate, delete the system automatically generated one in signup processing.
if ( $blog_id != '0' )
	wpmu_delete_blog( $blog_id, true );


foreach($the_array as $line) {

	//get the data from the array into strings
	$siteurl = $line[0];
	$blogdescription = $line[1];
	$blogname = $line[2];
	$user_id = $line[3];
	$admin_email = $line[4];
	$template_id = $line[5];
	
	
	//check for correct and non empty siteurl
	if ($domainmap){
		if (!bigtester_fessc_valid_url($siteurl)){
			_e("<span class=\"error\">The url '$siteurl' is not a valid url.</span>", 'acswpmu_trdom' );
			$error = TRUE;
		}
	}
	
	// Check first if domain already exists then add a new site
	if ($subdomain_install){
		if(!$error){ 
			if($exist_id = $wpdb->get_var("SELECT blog_id FROM $wpdb->blogs WHERE domain = '$fulldomain'")) {
				_e("<span class=\"error\">The URL $fulldomain already exist, we skipped it!</span>", 'acswpmu_trdom' );
				$error = TRUE;		
			} else {
				// Start with adding the new blog to the blogs table
				$new_blog_id = insert_blog( $domain, $path, '1');
				if(is_integer($new_blog_id)) {
					
				} else {
					_e("<span class=\"error\">The URL $domain already exist, we skipped it!</span>", 'acswpmu_trdom' );
					$error = TRUE;
				}
			}
		}
	} else {
		if(!$error){ 
			if($exist_id = $wpdb->get_var("SELECT blog_id FROM $wpdb->blogs WHERE path = '$path/'")) {
				_e("<span class=\"error\">The URL $fulldomain already exist, we skipped it!</span>", 'acswpmu_trdom' );
				$error = TRUE;		
			} else {
				// Start with adding the new blog to the blogs table
				$new_blog_id = insert_blog( $domain, $path, '1');
				if(is_integer($new_blog_id)) {
					
				} else {
					_e("<span class=\"error\">The URL $fulldomain already exist, we skipped it!</span>", 'acswpmu_trdom' );
					$error = TRUE;
				}
			}
		}
	}
	
	
	//Next duplicate all tables from the template
	if(!$error){
		
		//first update the duplicated blog id to old blog id.
		$wpdb->update( $wpdb->blogs, array('blog_id' => $blog_id), array('blog_id' => $new_blog_id) );
		$new_blog_id = $blog_id;
		//
		$template_like = $wpdb->prefix . $template_id . "_"; 
		$template_new = $wpdb->prefix . $new_blog_id . "_";
		$temp_like = str_replace('_', '\_', $template_like); //escape the _ for correct sql!!
		$template_tables = $wpdb->get_results( "SHOW TABLES LIKE '$temp_like%'", ARRAY_N );
		
		foreach ($template_tables as $old_table) {
			$new_table = str_replace($template_like, $template_new, $old_table[0]); 
			// check if table already exists
			if($wpdb->get_var("SHOW TABLES LIKE '$new_table'") != $new_table) {
				// duplicate the old table structure
				$result = $wpdb->query( "CREATE TABLE $new_table LIKE $old_table[0]" );
				if($result === FALSE) { 
					_e("<span class=\"error\">Failed to create $new_table.</span>", 'acswpmu_trdom' );
					$error = TRUE;
				} else { 
					
					// copy data from old_table to new_table
					$result = $wpdb->query( "INSERT INTO $new_table SELECT * FROM $old_table[0]" );
					if($result === FALSE) {
						_e("<span class=\"error\">Failed to copy data from $old_table[0] to $new_table.</span>", 'acswpmu_trdom' );
						$error = TRUE;
					} else {
						
					}						
				}
			} else { 
				_e("<span class=\"error\">The table $new_table already existed.</span>", 'acswpmu_trdom' );
				$error = TRUE;
			}
		}
	}

	// Then add user to the new blog
	if(!$error) {
		$role = "administrator";
		if ( add_user_to_blog( $new_blog_id, $user_id, $role ) ) {
		
		} else {
			_e( 'Failed to add user '.$user_id.' as '.$role.' to site '.$new_blog_id.'.<br/>', 'acswpmu_trdom' );
			$error = TRUE;
		}
	}
	
	// Add custom data to newly duplicated blog
	if(!$error) {
		$full_url = "http://" . $fulldomain;
		if(!$blogname) { $blogname = $siteurl; }
		$fileupload_url = $full_url . "/files";
		
		// update the cloned table with the new data and blog_id
		update_blog_option ($new_blog_id, 'siteurl', $full_url);
		update_blog_option ($new_blog_id, 'blogname', $blogname);
		update_blog_option ($new_blog_id, 'blogdescription', $blogdescription);
		update_blog_option ($new_blog_id, 'admin_email', $admin_email);
		update_blog_option ($new_blog_id, 'home', $full_url);
		update_blog_option ($new_blog_id, 'fileupload_url', $fileupload_url);
		update_blog_option ($new_blog_id, 'upload_path', 'wp-content/blogs.dir/' . $new_blog_id . '/files');
		$new_options_table = $wpdb->prefix . $new_blog_id . '_options';
		$old_name = $wpdb->prefix . $template_id . '_user_roles';
		$new_name = $wpdb->prefix . $new_blog_id . '_user_roles';
		$result = $wpdb->update( $new_options_table, array('option_name' => $new_name), array('option_name' => $old_name));
		
		// 'check' if it went ok - NOTE: is just a basic check could give an error anyway...
		if(get_blog_option($new_blog_id, 'blogdescription') != $blogdescription) { 
			//$error = TRUE; 
			_e("<span class=\"error\">Maybe we had an error updating the options table with the new data.</span>", 'acswpmu_trdom' );
		} else { 
		
		}
	}
	
	// add template_id to option table for later reference
	if(!$error) {
		$savearray = array ('template-id' => $template_id, 'lasttime' => time(),'deleted-non-cloned-blog-id' => $blog_id,'new-cloned-blog-id'=>$new_blog_id);
		add_blog_option ($new_blog_id, 'bigtester-fessc-signup-add-cloned-sites', serialize($savearray));
		//get it back with:
		//get_option('add-cloned-sites') == "" ? "" : $new = unserialize(get_option('add-cloned-sites'));
	}
	
	// Domainmap the newly cloned site
	if(!$error AND $domainmap) {
		$tbl_domain_map = $wpdb->prefix . "domain_mapping";
		// Check if domainmapping exists
		if($wpdb->get_var("SHOW TABLES LIKE '$tbl_domain_map'") == $tbl_domain_map) {
			// Map the domain
			$result = $wpdb->insert( $tbl_domain_map, array('blog_id' => $new_blog_id, 'domain' => $siteurl, 'active' => '1'));
			if($result) { 
		
			} else { 
				_e("<span class=\"error\">Domain mapping for $siteurl failed</span>", 'acswpmu_trdom' );
				$error = TRUE;
			}
		} else {
			_e("<span class=\"error\">Domainmapping failed because the domainmap plugin is not activated!</span>", 'acswpmu_trdom' );
			$error = TRUE;
		}
	}
	
	// Copy images and uploads
	// SPECIAL NOTE: This part of the code (copy files) I got from the plugin:
	// "new blog templates" by Jason DeVelvis and Ulrich Sossou
	// Special thanks go to you guys!
	if(!$error AND $copy_images) {
		global $wp_filesystem;

		$dir_to_copy = ABSPATH . 'wp-content/blogs.dir/' . $template_id . '/files';
		$dir_to_copy_into = ABSPATH .'wp-content/blogs.dir/' . $new_blog_id . '/files';

		if ( is_dir( $dir_to_copy ) ) {

			if ( wp_mkdir_p( $dir_to_copy_into ) ) {

				require_once( ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php' );
				require_once( ABSPATH . 'wp-admin/includes/class-wp-filesystem-direct.php' );

				if( isset( $wp_filesystem ) )
					$orig_filesystem = wp_clone( $wp_filesystem );
				$wp_filesystem = new WP_Filesystem_Direct( false );

				if ( ! defined('FS_CHMOD_DIR') )
					define('FS_CHMOD_DIR', 0755 );
				if ( ! defined('FS_CHMOD_FILE') )
					define('FS_CHMOD_FILE', 0644 );

				copy_dir( $dir_to_copy, $dir_to_copy_into );

				unset( $wp_filesystem );
				if( isset( $orig_filesystem ) )
					$wp_filesystem = wp_clone( $orig_filesystem );

				if ( @file_exists( $dir_to_copy_into . '/sitemap.xml' ) )
					@unlink( $dir_to_copy_into . '/sitemap.xml' );

			} else {
				_e("<span class=\"error\">Was unable to copy images and uploads!</span>", 'acswpmu_trdom' );
			}
		}
	}
	
	//reset permalink structure
	if(!$error) {
		switch_to_blog($new_blog_id);
		//_e("Switched from here to $new_blog_id to reset permalinks<br>", 'acswpmu_trdom' );
		global $wp_rewrite;
		$wp_rewrite->init();
		$wp_rewrite->flush_rules();
		//now that we are here, update the date of the new site
		wpmu_update_blogs_date( );
		//go back to admin
		restore_current_blog();
		
	}

	// count succesfull and failed sites
	if(!$error) { 
		
		if($domainmap) { _e("and mapped the site to: <a href=\"http://$siteurl\" target=\"test\">$siteurl</a>.<br>", 'acswpmu_trdom' ); }
		// count succesfull cloned sites
		$cloned[] = $siteurl;
	} else {
		// count failed sites
		$failed[] = $siteurl;
		$error = NULL;
	} 
	
}
}


/**
 * Inserts password entered by user if option chosen to let users enter own password instead of using default random password emailing
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_CreatePassword($password) {
	global $wpdb;
	
	$pswd = '';

		if (!is_multisite()) {
			if (isset($_POST['pass1'])){
				$pswd = $_POST['pass1'];
			}
		}else{
			$pswd = $_POST['pass1'];
		}
	
	return $pswd;
}

/**
 * Adds the translation directory to the plugin folder
 *
 * @since 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_translationFile(){
	
	$plugin_path = plugin_basename( dirname(__FILE__).'/translations' );
	load_plugin_textdomain('frontend-signup-site-clone', '', $plugin_path );
}


/**
 * Add the management page to the user settings bar
 *
 * @since 1.0.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_optionsPage(){
	
	if(function_exists('add_menu_page')){
		
		add_menu_page('Signup Site Clone','Signup Site Clone', 'manage_options','frontend-signup-site-clone', 'bigtester_fessc_myOptionsSubpanel', '', 71 );
    
	}
	
}

/**
 * Add options page for the Registration Form options
 *
 * @since 1.0.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_regFormOptionsPage(){
	
	if(function_exists('add_submenu_page')){
	
		add_submenu_page('user-registration-aide','Registration Form Options', 'Registration Form Options', 'manage_options', 'registration-form-options', 'bigtester_fessc_regFormOptions' );
    
	}
	
}

/**
 * Add the Add-Edit New Fields management page to the user settings bar
 *
 * @since 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_editNewFields_optionsPage(){
	
	if(function_exists('add_submenu_page')){
	
		add_submenu_page('user-registration-aide','Edit New Fields', 'Edit New Fields', 'manage_options', 'edit-new-fields', 'bigtester_fessc_editNewFields' );
    
	}
	
}

/**
 * Add custom logo to the registration page instead of wordpress logo
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_logo = $bigtester_fessc_Options['show_logo'];
	$logo_url = $bigtester_fessc_Options['logo_url'];
	 
	if ($show_logo == "1"){
		echo '<style type="text/css">h1 a { background-image:url('.$logo_url.') !important; height:150px; margin-bottom:20px; } </style>';
	}
	
	
}

/**
 * Add custom background image to the registration and login forms instead of default wordpress white
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header_Bckgrd_Image(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_background_image = $bigtester_fessc_Options['show_background_image'];
	$background_image = $bigtester_fessc_Options['background_image_url'];
	
	if($show_background_image =="1"){
		echo '<style type="text/css">#loginform{background:url('.$background_image.') no-repeat center;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; } </style>';
		echo '<style type="text/css">#registerform{background:url('.$background_image.') no-repeat center;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; } </style>';
	}
	
}

/**
 * Add custom background color to the registration and login forms instead of default wordpress white
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header_Bckgrd_Color(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_background_color = $bigtester_fessc_Options['show_background_color'];
	$background_color = $bigtester_fessc_Options['reg_background_color'];
	
	if($show_background_color == "1"){
		 echo '<style type="text/css">#loginform{background-color:'.$background_color.' !important;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif;} </style>';
		 echo '<style type="text/css">#registerform{background-color:'.$background_color.' !important;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif;} </style>';
	}
	
}

/**
 * Add custom background color to the registration and login pages instead of default wordpress white
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header_Page_Bckgrd_Color(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_page_color = $bigtester_fessc_Options['show_reg_form_page_color'];
	$page_color = $bigtester_fessc_Options['reg_form_page_color'];
	if($show_page_color == "1"){
		echo '<style type="text/css">body.login{height:350%; overflow:scroll; background-color:'.$page_color.' !important;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif;} </style>';
		// echo '<style type="text/css">body.register{overflow:scroll;  background-color:'.$page_color.' repeat !important; padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; } #content {background-color:'.$page_color.' ;} </style>';
	}
}

/**
 * Add custom background image to the registration and login pages instead of default wordpress white
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header_Page_Bckgrd_Image(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_page_image = $bigtester_fessc_Options['show_reg_form_page_image'];
	$page_image = $bigtester_fessc_Options['reg_form_page_image'];
		
		if($show_page_image == "1"){
		echo '<style type="text/css">body.login{height:350%; background:url('.$page_image.') repeat center;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; } </style>';
		echo '<style type="text/css">body.register{background:url('.$page_image.') repeat center;padding-top:30px;font:11px "Lucida Grande",Verdana,Arial,"Bitstream Vera Sans",sans-serif; } </style>';
	}
}

/**
 * Add custom label text colors to the registration and login forms instead of default wordpress colors
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Logo_Header_Label_Color(){
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	$show_text_color = $bigtester_fessc_Options['show_login_text_color'];
	$text_color = $bigtester_fessc_Options['login_text_color'];
	$hover_color = $bigtester_fessc_Options['hover_text_color'];
		
		if($show_text_color == "1"){
			echo '<style type="text/css">#loginform label{ font-family: verdana,arial; font-size:1.0em; color: '.$text_color.'; font-weight:bold;}';
			echo '#registerform label{font-family: verdana,arial; font-size:1.0em; color: '.$text_color.'; font-weight:bold;} ';
			echo 'body.login #nav a  { color:'.$text_color.' !important;  }';
			echo '.login #backtoblog a { color:'.$text_color.' !important; }';
			echo '.login #nav a:hover { color:'.$hover_color.' !important;  }';
			echo '.login #backtoblog a:hover { color:'.$hover_color.' !important; } </style>';
			
		}
}

/**
 * Sets Custom Logo link to site url if option chosen to add custom logo
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_CustomLoginLink(){

	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	if ($bigtester_fessc_Options['change_logo_link'] == "2"){
		return 'http://www.wordpress.org';
	}
	if ($bigtester_fessc_Options['change_logo_link'] == "1"){
		return site_url();
	}
}

/**
 * Sets hover title for Custom Logo if option chosen to add custom logo
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_Login_HeaderTitle(){

	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	if ($bigtester_fessc_Options['change_logo_link'] == "2"){
		return;
	}
	if ($bigtester_fessc_Options['change_logo_link'] == "1"){
		return get_bloginfo('name');
	}
	//return get_bloginfo('name');
	
}

/**
 * Add fields to the new user registration page that the user must fill out when they register
 *
 * @since 1.0.0
 * @updated 1.1.2
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_addFields(){

	global $bigtester_fesscFields;
	
	?>
	
	<style>
	#pass-strength-result{
	padding-top: 3px;
	padding-right: 5px;
	padding-bottom: 3px;
	padding-left: 5px;
	margin-top: 3px;
	text-align: center;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-right-style: solid;
	border-bottom-style: solid;
	border-left-style: solid;
	display:block;
	}
	
	</style>
	
	<?php
	
	$fieldKey = '';
	$fieldName = '';
	$bigtester_fesscFields = array();
	
	$bigtester_fesscFields = get_option('bigtester_fesscFields');
	
	
	if(is_array($bigtester_fesscFields)){
		if(!empty($bigtester_fesscFields)){
			foreach($bigtester_fesscFields as $fieldKey => $fieldName){
				
				echo '<p>';?>
				<label><?php _e($bigtester_fesscFields[$fieldKey], 'bigtester_fessc') ?><br />
				<input type="text" name="<?php echo $fieldKey; ?>" id="<?php echo $fieldKey; ?>" class="input" value="" size="25" style="font-size: 20px; width: 97%;	padding: 3px; margin-right: 6px;" /></label>
			
			<?php 
				echo '</p>';
		
			
			}
			wp_nonce_field('userRegAideRegForm','userRegAideNonce'); 
			
		}
	}
}

function bigtester_fessc_Password_Header(){

	if(function_exists('bigtester_fessc_Password_Options')){
			bigtester_fessc_Password_Options();
	}
	
	$bigtester_fessc_registrationFields = array();
	$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
	$word = "Password";
	$user_login = '';
	$user_email = '';
	$csds_pwd_options = get_option( 'csds_pwd_options' );
	
		if( isset( $_GET['user_login'] ) ) $user_login = $_GET['user_login'];
		if( isset( $_GET['user_email'] ) ) $user_email = $_GET['user_email'];
		
		?>
		<script type='text/javascript' src='<?php trailingslashit(get_option('siteurl'));?>wp-includes/js/jquery/jquery.js?ver=1.7.1'></script>
		<!--<script type='text/javascript' src='<?php trailingslashit(get_option('siteurl'));?>wp-admin/js/common.js?ver=20080318'></script>-->
		<?php
		if(!empty($bigtester_fessc_registrationFields)){
			if(is_array($bigtester_fessc_registrationFields)){
				if (in_array("$word", $bigtester_fessc_registrationFields)){
?>

<script type='text/javascript' src='<?php trailingslashit(get_option('siteurl'));?>wp-includes/js/jquery/jquery.color.js?ver=2.0-4561'></script>
<script type='text/javascript'>
/* <![CDATA[ */
	pwsL10n = {
		short: "No Password Entered!",
		bad: "Password Entered is Bad, Too Weak",
		good: "Password Entered is fairly tough and is good to accept",
		strong: "Password Entered is very strong!",
		mismatch: "Password Entered does not match Password Confirm! Try Again Please!"
	}
/* ]]> */
</script>
<script type='text/javascript' src='<?php trailingslashit(get_option('siteurl'));?>wp-admin/js/password-strength-meter.dev.js?ver=20070405'></script>
<script type="text/javascript">
	function check_pass_strength ( ) {

		var pass = jQuery('#pass1').val();
		var pass2 = jQuery('#pass2').val();
		var user = jQuery('#user_login').val();

		// get the result as an object, i'm tired of typing it
		var res = jQuery('#pass-strength-result');

		var strength = passwordStrength(pass, user, pass2);

		jQuery(res).removeClass('empty short bad good strong mismatch');
		
		 if ( strength == 1 ) {
			// this catches 'Too short' and the off chance anything else comes along
			jQuery(res).addClass('short');
			jQuery(res).html( pwsL10n.short );
		}
		else if ( strength == 2 ) {
			jQuery(res).addClass('bad');
			jQuery(res).html( pwsL10n.bad );
		}
		else if ( strength == 3 ) {
			jQuery(res).addClass('good');
			jQuery(res).html( pwsL10n.good );
		}
		else if ( strength == 4 ) {
			jQuery(res).addClass('strong');
			jQuery(res).html( pwsL10n.strong );
		}
		else if ( strength == 5 ) {
			jQuery(res).addClass('mismatch');
			jQuery(res).html( pwsL10n.mismatch );
		}
		else {
			// this catches 'Too short' and the off chance anything else comes along
			jQuery(res).addClass('short');
			jQuery(res).html( pwsL10n.short );
		}

	}
	

	jQuery(function($) { 
		$('#pass1').keyup( check_pass_strength );
		$('#pass2').keyup( check_pass_strength )
		$('.color-palette').click(function(){$(this).siblings('input[name=admin_color]').attr('checked', 'checked')});
	} );
	
	jQuery(document).ready( function() {
		jQuery('#pass1,#pass2').attr('autocomplete','off');
		jQuery('#user_login').val('<?php echo $user_login; ?>');
		jQuery('#user_email').val('<?php echo $user_email; ?>');
    });
</script>
		<?php }
		} 
	}
}

/**
 * Add the additional metadata into the database after the new user is created
 *
 * @since 1.0.0
 * @updated 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/


function bigtester_fessc_updateFields($result){

	if ($_POST["signup_for"] == 'user') return $result; //only update fields in the blog signup page. 
	global $bigtester_fessc_Fields, $wpdb;
	
	
	//$user_id = $current_user->id;
	$thisValue = '';
	$fieldName = '';
	$newValue = '';
	$newPass = '';
	$addData = '';
	$newWebsite = '';
	$newCredentials = '';
	$bigtester_fesscFields = array();
	$bigtester_fesscFields = get_option('bigtester_fesscFields');
	
	if (wp_verify_nonce($_POST["userRegAideNonce"], 'userRegAideRegForm')){
		if ($bigtester_fesscFields){
			foreach($bigtester_fesscFields as $thisValue => $fieldName){
				if($_POST[$thisValue] != ''){
					$bigtester_fesscFields[$thisValue] = $_POST[$thisValue];
					$result[$thisValue] = $_POST[$thisValue];
				}
			}
		}
					
	}else{
		exit(__('Failed Security Verification', 'bigtester_fessc'));
	}
	
	return $result;
}

/**
 * Add the additional metadata into the database after the new user is created
 *
 * @since 1.0.0
 * @updated 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
 */


function bigtester_fessc_addMetaFields($meta){
	if ($_POST["signup_for"] == 'user') return $meta; //only add fields in the blog signup page. 
	global $bigtester_fessc_Fields, $wpdb;


	//$user_id = $current_user->id;
	$thisValue = '';
	$fieldName = '';
	$newValue = '';
	$newPass = '';
	$addData = '';
	$newWebsite = '';
	$newCredentials = '';
	$bigtester_fesscFields = array();
	$bigtester_fesscFields = get_option('bigtester_fesscFields');

	if (wp_verify_nonce($_POST["userRegAideNonce"], 'userRegAideRegForm')){
		if ($bigtester_fesscFields){
			foreach($bigtester_fesscFields as $thisValue => $fieldName){
				if($_POST[$thisValue] != ''){
					$meta[$thisValue] = $_POST[$thisValue];
				}
			}
		}

	}else{
		exit(__('Failed Security Verification', 'bigtester_fessc'));
	}

	return $meta;
}


// Remove default password message if user entered own password

//if(function_exists('remove_default_password_nag')){
	function remove_default_password_nag() {

		//global $user_ID;
		//$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
		//if(in_array("Password", $bigtester_fessc_registrationFields)){
			//delete_user_setting('default_password_nag', $user_ID);
			//update_user_option($user_ID, 'default_password_nag', true, true);
			return 0;
		//}
		
	}
//}

// Emails registration confirmation to new user

function csds_new_user_notification($user_id, $plaintext_pass = '') {
	
	$user = new WP_User($user_id);
	
    $user_login = stripslashes($user->user_login);
	$user_email = stripslashes($user->user_email);

		// The blogname option is escaped with esc_html on the way into the database in sanitize_option
	 
	    // we want to reverse this for the plain text arena of emails.
	 
	    $blogname = wp_specialchars_decode(get_option('blogname'), ENT_QUOTES);
	 
	    $message  = sprintf(__('A new user has registered on your site %s:'), $blogname) . "\r\n\r\n";
		$message .= sprintf(__('Username: %s'), $user_login) . "\r\n\r\n";
	    $message .= sprintf(__('E-mail: %s'), $user_email) . "\r\n";
	 
	    @wp_mail(get_option('admin_email'), sprintf(__('[%s] New User Registration Alert'), $blogname), $message);
	 
	    if ( empty($plaintext_pass) ){
	 
	        return;
		}
	 	
		$message  = sprintf(__('Thank you for registering with: %s'), $blogname) . "\r\n";
	    $message  .= sprintf(__('Username: %s'), $user_login) . "\r\n";
	    $message .= sprintf(__('Password: %s'), $plaintext_pass) . "\r\n";
	    $message .= wp_login_url() . "\r\n";
	 	 
	    wp_mail($user_email, sprintf(__('[%s] Your username and password'), $blogname), $message);
		
	 return;
}

/**
 * Check the new user registration form for errors
 *
 * @since 1.0.0
 * @updated 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_checkFields($errors, $username, $email){

	global $bigtester_fessc_registrationFields;
	$thisValue = '';
	$fieldName1 = '';
	$bigtester_fessc_registrationFields = array();
	$bigtester_fessc_registrationFields = get_option('bigtester_fessc_registrationFields');
	$bigtester_fessc_Options = array();
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	//$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
	if(!empty($bigtester_fessc_registrationFields)){
		foreach($bigtester_fessc_registrationFields as $thisValue => $fieldName1){
			if($thisValue != "user_pass"){
				if ($_POST[$thisValue] == '') {
					$errors->add('empty_'.$thisValue , __("<strong>ERROR</strong>: Please type your ".$bigtester_fessc_registrationFields[$thisValue].".",'bigtester_fessc'));
				}
						//return $errors;
				
			}elseif($thisValue == "user_pass"){
				// //to check password
				if(empty($_POST['pass1']) || $_POST['pass1'] == '' || empty($_POST['pass2']) || $_POST['pass2'] == ''){
						$errors->add('empty_password', __("<strong>ERROR</strong>: Please type your Password!", 'bigtester_fessc'));
						
				}elseif($_POST['pass1'] != $_POST['pass2']){
						$errors->add('password_mismatch', ___("<strong>ERROR</strong>: Password too short!", 'bigtester_fessc'));
						
				}else{
					//exit('Blow Up');//$_POST['user_pw'] = $_POST['pass1'];
				}
			}
		}
		
			if($bigtester_fessc_Options['show_custom_agreement_checkbox'] == 1){
				if($_POST['bigtester_fessc_agree'] == 2){
					$errors->add('agreement_confirmation', __("<strong>ERROR</strong>: You must agree to the terms and conditions!", 'bigtester_fessc'));
					
				}
			}
	}
	return $errors;
}

/**
 * Add the additional fields added to the user profile page
 *
 * @since 1.0.0
 * @updated 1.1.2
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
	
function csds_show_user_profile($user){
 
 global $bigtester_fessc_NewFields;
	
	$user_id = $user->ID;
	$fieldKey = '';
	$fieldName = '';
	$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
	$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
	echo '<h3>Frontend Signup Site Clone Additional Fields</h3>';
	$csds_current_user = wp_get_current_user();
		if(current_user_can('edit_user', $user_id)){
			if(!empty($bigtester_fessc_NewFields)){
				foreach($bigtester_fessc_NewFields as $fieldKey => $fieldName){
				
					?>
					<table class="form-table">
					<tr>
					<th><label for="<?php echo $fieldKey ?>"><?php echo $fieldName ?></label></th>
					<td><input type="text" name="<?php echo $fieldKey ?>" id="<?php echo $fieldKey ?>" value="<?php echo esc_attr(get_user_meta($user_id, $fieldKey, TRUE)) ?>" class="regular-text" /></td>
					</tr>
					<?php
					
				}
					echo '</table>';
					
			wp_nonce_field('userRegAideProfileForm', 'userRegAideProfileNonce');
					
			echo '<br/>';				
				if($bigtester_fessc_Options['show_support'] == "1"){
					echo '<a target="_blank" href="'.$bigtester_fessc_Options['support_display_link'].'">' . $bigtester_fessc_Options['support_display_name'] . '</a>';
					echo '<br/>';
				}
			}
		}else{
			exit(__('Naughty, Naughty! You do not havve permissions to do this!', 'bigtester_fessc'));
		}
}
 
 /**
 * Updates the additional fields data added to the user profile page
 * @since 1.0.0 
 * @updated  1.1.2
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
 
 function csds_update_user_profile($user_id){
 
	global $wpdb;
	global $current_user, $bigtester_fessc_NewFields;
	$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
	$userID = $user_id;
	$fieldKey = '';
	$fieldName = '';
	$newValue = '';
	
	if(!empty($bigtester_fessc_NewFields)){
		$csds_current_user = wp_get_current_user();
		if(current_user_can('edit_user', $userID)){
			if(wp_verify_nonce($_POST["userRegAideProfileNonce"], 'userRegAideProfileForm')){
				foreach($bigtester_fessc_NewFields as $fieldKey => $fieldName){
					$newValue = $_POST[$fieldKey];
					if(!empty($newValue)){
					update_user_meta($userID, $fieldKey, $_POST[$fieldKey]);
					}
					else{
						//exit(__('New Value empty!'));
					}
				}
			}else{
				exit(__('Failed Security Check', 'bigtester_fessc'));
			}
		}else{
			exit(__('You do not have sufficient permissions to edit this user, contact a network administrator if this is an error!', 'bigtester_fessc'));
		}
	}else{
		//exit(__('New Fields Empty'));
	}
}

/**
 * Adds all the additional fields created to existing users meta
 *
 * @since 1.0.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
	
function csds_add_field_to_users_meta($field){

	global $wpdb;
	//include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	$count = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users;");
	$i = 1;
		while($i <= $count)
			{
				$user_id = $i;
				update_user_meta( $user_id, $field, "");
				$i++;
			}
}

/**
 * Deletes the additional fields from existing users meta
 *
 * @since 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/
	
function csds_delete_field_from_users_meta($field){

	global $wpdb;
	//include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	$count = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users;");
	$i = 1;
		while($i <= $count)
			{
				$user_id = $i;
				delete_user_meta( $user_id, $field, "");
				$i++;
			}
}

/**
 * Deactivation Function
 *
 * @since 1.0.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

function bigtester_fessc_deactivation()
{
	
}

//end CSDS_USER_REG_AIDE class

# Run The Plugin!
// if( class_exists('CSDS_USER_REG_AIDE') ){
	// $bigtester_fessc_Instance = new CSDS_USER_REG_AIDE();
	// if(isset($bigtester_fessc_Instance)){
		// if(function_exists('bigtester_fessc_install')){
			
		// }
		
	// }
// }


	
?>
